#!/bin/sh

#================================================
#== Adres IP serwera Zabbix =====================
ZABBIX_SERVER="xxx.xxx.xxx.xxx"
#================================================
#== Nazwa hosta na serwerze Zabbix ==============
HOST="czajnik"
#================================================
#== Link do ELECTRICITIMETER Channel ============
SUPLA_LINK_POWER="https://......................./read?format=json"
#== Link do RELAY Channel =======================
SUPLA_LINK_STATE="https://......................./read?format=json"
#================================================

NAZ0="/var/local/"$HOST"_"

#======================================================
FILE=$NAZ0"dailytime.txt"
if ! [ -f "$FILE" ]; then
  echo "2355" > $FILE
  detime=2355
else
  detime=`cat $FILE`
  if [ $detime -ne 2355 -a $detime -ne 2356 -a $detime -ne 2357 -a $detime -ne 2358 ]; then
    echo "2355" > $FILE
    detime=2355
  fi
fi
#======================================================

OUTPUT=$(curl -k "$SUPLA_LINK_STATE")
x_state=`echo $OUTPUT | jq '.on'`
if [ $x_state = true ]; then
  x_state=1
else
  x_state=0
fi
NAZ3="/tmp/"$HOST"_zab3.txt"
OUTPUT=$(curl -k "$SUPLA_LINK_POWER")
x_totalCost=`echo $OUTPUT | jq '.totalCost'`
x_pricePerUnit=`echo $OUTPUT | jq '.pricePerUnit'`
x_currency=`echo $OUTPUT | jq '.currency'`
x_voltage=`echo $OUTPUT | jq '.phases | .[0] | .voltage'`
x_current=`echo $OUTPUT | jq '.phases | .[0] | .current'`
x_powerActive=`echo $OUTPUT | jq '.phases | .[0] | .powerActive'`
x_totalForwardActiveEnergy=`echo $OUTPUT | jq '.phases | .[0] | .totalForwardActiveEnergy'`
x_voltage=`echo $x_voltage \* 10 | bc`
x_current=`echo $x_current \* 1000 | bc`
x_totalForwardActiveEnergy1=`echo $x_totalForwardActiveEnergy \* 100 | bc`
echo "$HOST state $x_state" > $NAZ3
echo "$HOST voltage $x_voltage" >> $NAZ3
echo "$HOST current $x_current" >> $NAZ3
echo "$HOST power $x_powerActive" >> $NAZ3
echo "$HOST fullpower $x_totalForwardActiveEnergy1" >> $NAZ3

#########################################################################
check=`echo "$x_powerActive" | grep -E ^\-?[0-9]*\.?[0-9]+$`
if [ "$check" != '' ]; then    
  #======================================================
  DATA="`date +"%H%M"`"
  if [ $DATA -ne $detime ]; then
    zabbix_sender -z "$ZABBIX_SERVER" -i $NAZ3 > /dev/null
  fi
  #======================================================
fi

#===========================================================================
#=== BILANS DNIA o 23.55 ===================================================
#===========================================================================
DATA="`date +"%H%M"`"
if [ $DATA -eq $detime ]; then

  check=`echo "$x_powerActive" | grep -E ^\-?[0-9]*\.?[0-9]+$`
  if [ "$check" != '' ]; then    
    #=== Energia dzienna pobrana ===========================================
    FILE=$NAZ0"dailyenergy.txt"
    if [ -f "$FILE" ]; then
      x_dailyenergy=`cat $FILE`
      x_dailyenergy=`echo $x_totalForwardActiveEnergy - $x_dailyenergy | bc`
      echo "$x_totalForwardActiveEnergy" > $FILE
      x_dailyenergy=`echo $x_dailyenergy \* 100 | bc`
      echo "$HOST dailypower $x_dailyenergy" > $NAZ3
      #======================================================
      zabbix_sender -z "$ZABBIX_SERVER" -i $NAZ3 > /dev/null
      #======================================================
      detime=2355
      echo "$detime" > $NAZ0"dailytime.txt"
    else
      echo "$x_totalForwardActiveEnergy" > $FILE
    fi
  else
    #==============================================================
    # Brak danych z serwera SUPLA
    #==============================================================
    detime=`echo  $detime + 1 | bc`
	if [ $detime -eq 2359 ]; then
      detime=2355
	fi
    echo "$detime" > $NAZ0"dailytime.txt"
  fi
  #########################################################################
fi
#===========================================================================
